Index: src/backend/utils/time/tqual.c
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/backend/utils/time/tqual.c,v
retrieving revision 1.86
diff -c -r1.86 tqual.c
*** src/backend/utils/time/tqual.c	20 Mar 2005 23:40:27 -0000	1.86
--- src/backend/utils/time/tqual.c	18 Apr 2005 23:04:30 -0000
***************
*** 23,28 ****
--- 23,29 ----
  
  #include "postgres.h"
  
+ #include "access/multixact.h"
  #include "access/subtrans.h"
  #include "storage/sinval.h"
  #include "utils/tqual.h"
***************
*** 139,145 ****
  
  			Assert(TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetXmax(tuple)));
  
! 			if (tuple->t_infomask & HEAP_MARKED_FOR_UPDATE)
  				return true;
  
  			return false;
--- 140,146 ----
  
  			Assert(TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetXmax(tuple)));
  
! 			if (tuple->t_infomask & HEAP_LOCKED)
  				return true;
  
  			return false;
***************
*** 167,206 ****
  
  	if (tuple->t_infomask & HEAP_XMAX_COMMITTED)
  	{
! 		if (tuple->t_infomask & HEAP_MARKED_FOR_UPDATE)
  			return true;
  		return false;			/* updated by other */
  	}
  
! 	if (TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetXmax(tuple)))
  	{
! 		if (tuple->t_infomask & HEAP_MARKED_FOR_UPDATE)
  			return true;
! 		return false;
! 	}
  
! 	if (!TransactionIdDidCommit(HeapTupleHeaderGetXmax(tuple)))
! 	{
! 		if (TransactionIdDidAbort(HeapTupleHeaderGetXmax(tuple)))
  		{
  			tuple->t_infomask |= HEAP_XMAX_INVALID;
  			SetBufferCommitInfoNeedsSave(buffer);
  		}
- 		return true;
- 	}
  
! 	/* xmax transaction committed */
! 
! 	if (tuple->t_infomask & HEAP_MARKED_FOR_UPDATE)
! 	{
! 		tuple->t_infomask |= HEAP_XMAX_INVALID;
  		SetBufferCommitInfoNeedsSave(buffer);
  		return true;
  	}
- 
- 	tuple->t_infomask |= HEAP_XMAX_COMMITTED;
- 	SetBufferCommitInfoNeedsSave(buffer);
- 	return false;
  }
  
  /*
--- 168,215 ----
  
  	if (tuple->t_infomask & HEAP_XMAX_COMMITTED)
  	{
! 		if (tuple->t_infomask & HEAP_LOCKED)
  			return true;
  		return false;			/* updated by other */
  	}
  
! 	if (!(tuple->t_infomask & HEAP_XMAX_SHARED_LOCK))
  	{
! 		if (TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetXmax(tuple)))
! 		{
! 			if (tuple->t_infomask & HEAP_XMAX_EXCLUSIVE_LOCK)
! 				return true;
! 			return false;
! 		}
! 
! 		if (!TransactionIdDidCommit(HeapTupleHeaderGetXmax(tuple)))
! 		{
! 			if (TransactionIdDidAbort(HeapTupleHeaderGetXmax(tuple)))
! 			{
! 				tuple->t_infomask |= HEAP_XMAX_INVALID;
! 				SetBufferCommitInfoNeedsSave(buffer);
! 			}
  			return true;
! 		}
  
! 		/* xmax transaction committed */
! 
! 		if (tuple->t_infomask & HEAP_XMAX_EXCLUSIVE_LOCK)
  		{
  			tuple->t_infomask |= HEAP_XMAX_INVALID;
  			SetBufferCommitInfoNeedsSave(buffer);
+ 			return true;
  		}
  
! 		tuple->t_infomask |= HEAP_XMAX_COMMITTED;
  		SetBufferCommitInfoNeedsSave(buffer);
+ 		return false;
+ 	}
+ 	else
+ 	{
+ 		/* Xmax is a MultiXactId */
  		return true;
  	}
  }
  
  /*
***************
*** 310,316 ****
  
  			Assert(TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetXmax(tuple)));
  
! 			if (tuple->t_infomask & HEAP_MARKED_FOR_UPDATE)
  				return true;
  
  			if (HeapTupleHeaderGetCmax(tuple) >= GetCurrentCommandId())
--- 319,325 ----
  
  			Assert(TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetXmax(tuple)));
  
! 			if (tuple->t_infomask & HEAP_LOCKED)
  				return true;
  
  			if (HeapTupleHeaderGetCmax(tuple) >= GetCurrentCommandId())
***************
*** 341,383 ****
  
  	if (tuple->t_infomask & HEAP_XMAX_COMMITTED)
  	{
! 		if (tuple->t_infomask & HEAP_MARKED_FOR_UPDATE)
  			return true;
  		return false;
  	}
  
! 	if (TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetXmax(tuple)))
  	{
! 		if (tuple->t_infomask & HEAP_MARKED_FOR_UPDATE)
  			return true;
! 		if (HeapTupleHeaderGetCmax(tuple) >= GetCurrentCommandId())
! 			return true;		/* deleted after scan started */
! 		else
! 			return false;		/* deleted before scan started */
! 	}
  
! 	if (!TransactionIdDidCommit(HeapTupleHeaderGetXmax(tuple)))
! 	{
! 		if (TransactionIdDidAbort(HeapTupleHeaderGetXmax(tuple)))
  		{
  			tuple->t_infomask |= HEAP_XMAX_INVALID;
  			SetBufferCommitInfoNeedsSave(buffer);
  		}
- 		return true;
- 	}
- 
- 	/* xmax transaction committed */
  
! 	if (tuple->t_infomask & HEAP_MARKED_FOR_UPDATE)
! 	{
! 		tuple->t_infomask |= HEAP_XMAX_INVALID;
  		SetBufferCommitInfoNeedsSave(buffer);
  		return true;
  	}
- 
- 	tuple->t_infomask |= HEAP_XMAX_COMMITTED;
- 	SetBufferCommitInfoNeedsSave(buffer);
- 	return false;
  }
  
  /*
--- 350,400 ----
  
  	if (tuple->t_infomask & HEAP_XMAX_COMMITTED)
  	{
! 		if (tuple->t_infomask & HEAP_LOCKED)
  			return true;
  		return false;
  	}
  
! 	if (!(tuple->t_infomask & HEAP_XMAX_SHARED_LOCK))
  	{
! 		if (TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetXmax(tuple)))
! 		{
! 			if (tuple->t_infomask & HEAP_XMAX_EXCLUSIVE_LOCK)
! 				return true;
! 			if (HeapTupleHeaderGetCmax(tuple) >= GetCurrentCommandId())
! 				return true;		/* deleted after scan started */
! 			else
! 				return false;		/* deleted before scan started */
! 		}
! 
! 		if (!TransactionIdDidCommit(HeapTupleHeaderGetXmax(tuple)))
! 		{
! 			if (TransactionIdDidAbort(HeapTupleHeaderGetXmax(tuple)))
! 			{
! 				tuple->t_infomask |= HEAP_XMAX_INVALID;
! 				SetBufferCommitInfoNeedsSave(buffer);
! 			}
  			return true;
! 		}
  
! 		/* xmax transaction committed */
! 
! 		if (tuple->t_infomask & HEAP_XMAX_EXCLUSIVE_LOCK)
  		{
  			tuple->t_infomask |= HEAP_XMAX_INVALID;
  			SetBufferCommitInfoNeedsSave(buffer);
+ 			return true;
  		}
  
! 		tuple->t_infomask |= HEAP_XMAX_COMMITTED;
  		SetBufferCommitInfoNeedsSave(buffer);
+ 		return false;
+ 	}
+ 	else
+ 	{
+ 		/* Xmax is a MultiXactId */
  		return true;
  	}
  }
  
  /*
***************
*** 454,459 ****
--- 471,492 ----
   *	code, since UPDATE needs to know more than "is it visible?".  Also,
   *	tuples of my own xact are tested against the passed CommandId not
   *	CurrentCommandId.
+  *
+  *	The possible return codes are:
+  *
+  *	HeapTupleInvisible: the tuple didn't exist at all when the scan started,
+  *	e.g. it was created by a later CommandId.
+  *
+  *	HeapTupleMayBeUpdated: The tuple is valid and visible, so it may be
+  *	updated.
+  *
+  *	HeapTupleSelfUpdated: The tuple was updated by the current transaction,
+  *	after the current scan started.
+  *
+  *	HeapTupleUpdated: The tuple was updated by a committed transaction.
+  *
+  *	HeapTupleBeingUpdated: The tuple is being updated by an in-progress
+  *	transaction other than the current transaction.
   */
  HTSU_Result
  HeapTupleSatisfiesUpdate(HeapTupleHeader tuple, CommandId curcid,
***************
*** 522,528 ****
  
  			Assert(TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetXmax(tuple)));
  
! 			if (tuple->t_infomask & HEAP_MARKED_FOR_UPDATE)
  				return HeapTupleMayBeUpdated;
  
  			if (HeapTupleHeaderGetCmax(tuple) >= curcid)
--- 555,561 ----
  
  			Assert(TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetXmax(tuple)));
  
! 			if (tuple->t_infomask & HEAP_LOCKED)
  				return HeapTupleMayBeUpdated;
  
  			if (HeapTupleHeaderGetCmax(tuple) >= curcid)
***************
*** 555,600 ****
  
  	if (tuple->t_infomask & HEAP_XMAX_COMMITTED)
  	{
! 		if (tuple->t_infomask & HEAP_MARKED_FOR_UPDATE)
  			return HeapTupleMayBeUpdated;
  		return HeapTupleUpdated;	/* updated by other */
  	}
  
! 	if (TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetXmax(tuple)))
  	{
! 		if (tuple->t_infomask & HEAP_MARKED_FOR_UPDATE)
! 			return HeapTupleMayBeUpdated;
! 		if (HeapTupleHeaderGetCmax(tuple) >= curcid)
! 			return HeapTupleSelfUpdated;		/* updated after scan
! 												 * started */
! 		else
! 			return HeapTupleInvisible;	/* updated before scan started */
! 	}
  
! 	if (!TransactionIdDidCommit(HeapTupleHeaderGetXmax(tuple)))
! 	{
! 		if (TransactionIdDidAbort(HeapTupleHeaderGetXmax(tuple)))
  		{
  			tuple->t_infomask |= HEAP_XMAX_INVALID;
  			SetBufferCommitInfoNeedsSave(buffer);
  			return HeapTupleMayBeUpdated;
  		}
- 		/* running xact */
- 		return HeapTupleBeingUpdated;	/* in updation by other */
- 	}
- 
- 	/* xmax transaction committed */
  
! 	if (tuple->t_infomask & HEAP_MARKED_FOR_UPDATE)
! 	{
! 		tuple->t_infomask |= HEAP_XMAX_INVALID;
  		SetBufferCommitInfoNeedsSave(buffer);
! 		return HeapTupleMayBeUpdated;
  	}
- 
- 	tuple->t_infomask |= HEAP_XMAX_COMMITTED;
- 	SetBufferCommitInfoNeedsSave(buffer);
- 	return HeapTupleUpdated;	/* updated by other */
  }
  
  /*
--- 588,652 ----
  
  	if (tuple->t_infomask & HEAP_XMAX_COMMITTED)
  	{
! 		if (tuple->t_infomask & HEAP_LOCKED)
  			return HeapTupleMayBeUpdated;
  		return HeapTupleUpdated;	/* updated by other */
  	}
  
! 	/*
! 	 * If it isn't share-locked then Xmax is a real Xid.
! 	 */
! 	if (!(tuple->t_infomask & HEAP_XMAX_SHARED_LOCK))
  	{
! 		if (TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetXmax(tuple)))
! 		{
! 			if (tuple->t_infomask & HEAP_XMAX_EXCLUSIVE_LOCK)
! 				return HeapTupleMayBeUpdated;
! 			if (HeapTupleHeaderGetCmax(tuple) >= curcid)
! 				return HeapTupleSelfUpdated;		/* updated after scan
! 													 * started */
! 			else
! 				return HeapTupleInvisible;	/* updated before scan started */
! 		}
  
! 		if (!TransactionIdDidCommit(HeapTupleHeaderGetXmax(tuple)))
! 		{
! 			if (TransactionIdDidAbort(HeapTupleHeaderGetXmax(tuple)))
! 			{
! 				tuple->t_infomask |= HEAP_XMAX_INVALID;
! 				SetBufferCommitInfoNeedsSave(buffer);
! 				return HeapTupleMayBeUpdated;
! 			}
! 			/* running xact */
! 			return HeapTupleBeingUpdated;	/* in updation by other */
! 		}
! 
! 		/* xmax transaction committed */
! 
! 		if (tuple->t_infomask & HEAP_XMAX_EXCLUSIVE_LOCK)
  		{
  			tuple->t_infomask |= HEAP_XMAX_INVALID;
  			SetBufferCommitInfoNeedsSave(buffer);
  			return HeapTupleMayBeUpdated;
  		}
  
! 		tuple->t_infomask |= HEAP_XMAX_COMMITTED;
  		SetBufferCommitInfoNeedsSave(buffer);
! 		return HeapTupleUpdated;	/* updated by other */
! 	}
! 	else
! 	{
! 		/* Xmax is a MultiXactId */
! 		if (MultiXactIdIsRunning(HeapTupleHeaderGetXmax(tuple)))
! 			return HeapTupleBeingUpdated;
! 		else
! 		{
! 			tuple->t_infomask &= ~(HEAP_XMAX_SHARED_LOCK);
! 			tuple->t_infomask |= HEAP_XMAX_INVALID;
! 			SetBufferCommitInfoNeedsSave(buffer);
! 			return HeapTupleMayBeUpdated;
! 		}
  	}
  }
  
  /*
***************
*** 679,685 ****
  
  			Assert(TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetXmax(tuple)));
  
! 			if (tuple->t_infomask & HEAP_MARKED_FOR_UPDATE)
  				return true;
  
  			return false;
--- 731,737 ----
  
  			Assert(TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetXmax(tuple)));
  
! 			if (tuple->t_infomask & HEAP_LOCKED)
  				return true;
  
  			return false;
***************
*** 710,716 ****
  
  	if (tuple->t_infomask & HEAP_XMAX_COMMITTED)
  	{
! 		if (tuple->t_infomask & HEAP_MARKED_FOR_UPDATE)
  			return true;
  		SnapshotDirty->tid = tuple->t_ctid;
  		return false;			/* updated by other */
--- 762,768 ----
  
  	if (tuple->t_infomask & HEAP_XMAX_COMMITTED)
  	{
! 		if (tuple->t_infomask & HEAP_LOCKED)
  			return true;
  		SnapshotDirty->tid = tuple->t_ctid;
  		return false;			/* updated by other */
***************
*** 718,754 ****
  
  	if (TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetXmax(tuple)))
  	{
! 		if (tuple->t_infomask & HEAP_MARKED_FOR_UPDATE)
  			return true;
  		return false;
  	}
  
! 	if (!TransactionIdDidCommit(HeapTupleHeaderGetXmax(tuple)))
  	{
! 		if (TransactionIdDidAbort(HeapTupleHeaderGetXmax(tuple)))
  		{
  			tuple->t_infomask |= HEAP_XMAX_INVALID;
  			SetBufferCommitInfoNeedsSave(buffer);
  			return true;
  		}
- 		/* running xact */
- 		SnapshotDirty->xmax = HeapTupleHeaderGetXmax(tuple);
- 		return true;			/* in updation by other */
- 	}
  
! 	/* xmax transaction committed */
! 
! 	if (tuple->t_infomask & HEAP_MARKED_FOR_UPDATE)
! 	{
! 		tuple->t_infomask |= HEAP_XMAX_INVALID;
  		SetBufferCommitInfoNeedsSave(buffer);
  		return true;
  	}
- 
- 	tuple->t_infomask |= HEAP_XMAX_COMMITTED;
- 	SetBufferCommitInfoNeedsSave(buffer);
- 	SnapshotDirty->tid = tuple->t_ctid;
- 	return false;				/* updated by other */
  }
  
  /*
--- 770,814 ----
  
  	if (TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetXmax(tuple)))
  	{
! 		if (tuple->t_infomask & HEAP_LOCKED)
  			return true;
  		return false;
  	}
  
! 	if (!(tuple->t_infomask & HEAP_XMAX_SHARED_LOCK))
  	{
! 		if (!TransactionIdDidCommit(HeapTupleHeaderGetXmax(tuple)))
! 		{
! 			if (TransactionIdDidAbort(HeapTupleHeaderGetXmax(tuple)))
! 			{
! 				tuple->t_infomask |= HEAP_XMAX_INVALID;
! 				SetBufferCommitInfoNeedsSave(buffer);
! 				return true;
! 			}
! 			/* running xact */
! 			SnapshotDirty->xmax = HeapTupleHeaderGetXmax(tuple);
! 			return true;			/* in updation by other */
! 		}
! 
! 		/* xmax transaction committed */
! 
! 		if (tuple->t_infomask & HEAP_XMAX_EXCLUSIVE_LOCK)
  		{
  			tuple->t_infomask |= HEAP_XMAX_INVALID;
  			SetBufferCommitInfoNeedsSave(buffer);
  			return true;
  		}
  
! 		tuple->t_infomask |= HEAP_XMAX_COMMITTED;
  		SetBufferCommitInfoNeedsSave(buffer);
+ 		SnapshotDirty->tid = tuple->t_ctid;
+ 		return false;				/* updated by other */
+ 	}
+ 	else
+ 	{
+ 		/* Xmax is a MultiXactId */
  		return true;
  	}
  }
  
  /*
***************
*** 839,845 ****
  
  			Assert(TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetXmax(tuple)));
  
! 			if (tuple->t_infomask & HEAP_MARKED_FOR_UPDATE)
  				return true;
  
  			if (HeapTupleHeaderGetCmax(tuple) >= snapshot->curcid)
--- 899,905 ----
  
  			Assert(TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetXmax(tuple)));
  
! 			if (tuple->t_infomask & HEAP_LOCKED)
  				return true;
  
  			if (HeapTupleHeaderGetCmax(tuple) >= snapshot->curcid)
***************
*** 902,933 ****
  	if (tuple->t_infomask & HEAP_XMAX_INVALID)	/* xid invalid or aborted */
  		return true;
  
! 	if (tuple->t_infomask & HEAP_MARKED_FOR_UPDATE)
  		return true;
  
  	if (!(tuple->t_infomask & HEAP_XMAX_COMMITTED))
  	{
! 		if (TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetXmax(tuple)))
  		{
! 			if (HeapTupleHeaderGetCmax(tuple) >= snapshot->curcid)
! 				return true;	/* deleted after scan started */
! 			else
! 				return false;	/* deleted before scan started */
! 		}
  
! 		if (!TransactionIdDidCommit(HeapTupleHeaderGetXmax(tuple)))
! 		{
! 			if (TransactionIdDidAbort(HeapTupleHeaderGetXmax(tuple)))
  			{
! 				tuple->t_infomask |= HEAP_XMAX_INVALID;
! 				SetBufferCommitInfoNeedsSave(buffer);
  			}
  			return true;
  		}
- 
- 		/* xmax transaction committed */
- 		tuple->t_infomask |= HEAP_XMAX_COMMITTED;
- 		SetBufferCommitInfoNeedsSave(buffer);
  	}
  
  	/*
--- 962,1001 ----
  	if (tuple->t_infomask & HEAP_XMAX_INVALID)	/* xid invalid or aborted */
  		return true;
  
! 	if (tuple->t_infomask & HEAP_LOCKED)
  		return true;
  
  	if (!(tuple->t_infomask & HEAP_XMAX_COMMITTED))
  	{
! 		if (!(tuple->t_infomask & HEAP_XMAX_SHARED_LOCK))
  		{
! 			if (TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetXmax(tuple)))
! 			{
! 				if (HeapTupleHeaderGetCmax(tuple) >= snapshot->curcid)
! 					return true;	/* deleted after scan started */
! 				else
! 					return false;	/* deleted before scan started */
! 			}
  
! 			if (!TransactionIdDidCommit(HeapTupleHeaderGetXmax(tuple)))
  			{
! 				if (TransactionIdDidAbort(HeapTupleHeaderGetXmax(tuple)))
! 				{
! 					tuple->t_infomask |= HEAP_XMAX_INVALID;
! 					SetBufferCommitInfoNeedsSave(buffer);
! 				}
! 				return true;
  			}
+ 
+ 			/* xmax transaction committed */
+ 			tuple->t_infomask |= HEAP_XMAX_COMMITTED;
+ 			SetBufferCommitInfoNeedsSave(buffer);
+ 		}
+ 		else
+ 		{
+ 			/* Xmax is a MultiXactId */
  			return true;
  		}
  	}
  
  	/*
***************
*** 1043,1049 ****
  		{
  			if (tuple->t_infomask & HEAP_XMAX_INVALID)	/* xid invalid */
  				return HEAPTUPLE_INSERT_IN_PROGRESS;
! 			if (tuple->t_infomask & HEAP_MARKED_FOR_UPDATE)
  				return HEAPTUPLE_INSERT_IN_PROGRESS;
  			/* inserted and then deleted by same xact */
  			return HEAPTUPLE_DELETE_IN_PROGRESS;
--- 1111,1117 ----
  		{
  			if (tuple->t_infomask & HEAP_XMAX_INVALID)	/* xid invalid */
  				return HEAPTUPLE_INSERT_IN_PROGRESS;
! 			if (tuple->t_infomask & HEAP_LOCKED)
  				return HEAPTUPLE_INSERT_IN_PROGRESS;
  			/* inserted and then deleted by same xact */
  			return HEAPTUPLE_DELETE_IN_PROGRESS;
***************
*** 1074,1080 ****
  	if (tuple->t_infomask & HEAP_XMAX_INVALID)
  		return HEAPTUPLE_LIVE;
  
! 	if (tuple->t_infomask & HEAP_MARKED_FOR_UPDATE)
  	{
  		/*
  		 * "Deleting" xact really only marked it for update, so the tuple
--- 1142,1148 ----
  	if (tuple->t_infomask & HEAP_XMAX_INVALID)
  		return HEAPTUPLE_LIVE;
  
! 	if (tuple->t_infomask & HEAP_LOCKED)
  	{
  		/*
  		 * "Deleting" xact really only marked it for update, so the tuple
***************
*** 1100,1124 ****
  
  	if (!(tuple->t_infomask & HEAP_XMAX_COMMITTED))
  	{
! 		if (TransactionIdIsInProgress(HeapTupleHeaderGetXmax(tuple)))
! 			return HEAPTUPLE_DELETE_IN_PROGRESS;
! 		else if (TransactionIdDidCommit(HeapTupleHeaderGetXmax(tuple)))
  		{
! 			tuple->t_infomask |= HEAP_XMAX_COMMITTED;
! 			SetBufferCommitInfoNeedsSave(buffer);
  		}
  		else
  		{
! 			/*
! 			 * Not in Progress, Not Committed, so either Aborted or
! 			 * crashed
! 			 */
! 			tuple->t_infomask |= HEAP_XMAX_INVALID;
! 			SetBufferCommitInfoNeedsSave(buffer);
  			return HEAPTUPLE_LIVE;
  		}
- 		/* Should only get here if we set XMAX_COMMITTED */
- 		Assert(tuple->t_infomask & HEAP_XMAX_COMMITTED);
  	}
  
  	/*
--- 1168,1200 ----
  
  	if (!(tuple->t_infomask & HEAP_XMAX_COMMITTED))
  	{
! 		if (!(tuple->t_infomask & HEAP_XMAX_SHARED_LOCK))
  		{
! 			if (TransactionIdIsInProgress(HeapTupleHeaderGetXmax(tuple)))
! 				return HEAPTUPLE_DELETE_IN_PROGRESS;
! 			else if (TransactionIdDidCommit(HeapTupleHeaderGetXmax(tuple)))
! 			{
! 				tuple->t_infomask |= HEAP_XMAX_COMMITTED;
! 				SetBufferCommitInfoNeedsSave(buffer);
! 			}
! 			else
! 			{
! 				/*
! 				 * Not in Progress, Not Committed, so either Aborted or
! 				 * crashed
! 				 */
! 				tuple->t_infomask |= HEAP_XMAX_INVALID;
! 				SetBufferCommitInfoNeedsSave(buffer);
! 				return HEAPTUPLE_LIVE;
! 			}
! 			/* Should only get here if we set XMAX_COMMITTED */
! 			Assert(tuple->t_infomask & HEAP_XMAX_COMMITTED);
  		}
  		else
  		{
! 			/* Xmax is a MultiXactId */
  			return HEAPTUPLE_LIVE;
  		}
  	}
  
  	/*
Index: src/bin/initdb/initdb.c
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/bin/initdb/initdb.c,v
retrieving revision 1.81
diff -c -r1.81 initdb.c
*** src/bin/initdb/initdb.c	12 Apr 2005 19:29:24 -0000	1.81
--- src/bin/initdb/initdb.c	18 Apr 2005 22:02:05 -0000
***************
*** 527,533 ****
  		{
  			/*
  			 * POSIX 1003.2: For each dir operand that does not name an
! 			 * existing directory, effects equivalent to those cased by
  			 * the following command shall occcur:
  			 *
  			 * mkdir -p -m $(umask -S),u+wx $(dirname dir) && mkdir [-m mode]
--- 527,533 ----
  		{
  			/*
  			 * POSIX 1003.2: For each dir operand that does not name an
! 			 * existing directory, effects equivalent to those caused by
  			 * the following command shall occcur:
  			 *
  			 * mkdir -p -m $(umask -S),u+wx $(dirname dir) && mkdir [-m mode]
***************
*** 2120,2130 ****
  	char		*pg_data_native;
  	static const char *subdirs[] = {
  		"global",
- 		"pg_xlog",
  		"pg_xlog/archive_status",
  		"pg_clog",
  		"pg_subtrans",
! 		"base",
  		"base/1",
  		"pg_tblspc"
  	};
--- 2120,2130 ----
  	char		*pg_data_native;
  	static const char *subdirs[] = {
  		"global",
  		"pg_xlog/archive_status",
  		"pg_clog",
  		"pg_subtrans",
! 		"pg_multixact/members",
! 		"pg_multixact/offsets",
  		"base/1",
  		"pg_tblspc"
  	};
Index: src/bin/pg_controldata/pg_controldata.c
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/bin/pg_controldata/pg_controldata.c,v
retrieving revision 1.22
diff -c -r1.22 pg_controldata.c
*** src/bin/pg_controldata/pg_controldata.c	29 Mar 2005 03:01:32 -0000	1.22
--- src/bin/pg_controldata/pg_controldata.c	16 Apr 2005 18:17:09 -0000
***************
*** 165,170 ****
--- 165,171 ----
  	printf(_("Latest checkpoint's TimeLineID:       %u\n"), ControlFile.checkPointCopy.ThisTimeLineID);
  	printf(_("Latest checkpoint's NextXID:          %u\n"), ControlFile.checkPointCopy.nextXid);
  	printf(_("Latest checkpoint's NextOID:          %u\n"), ControlFile.checkPointCopy.nextOid);
+ 	printf(_("Latest checkpoint's NextMultiXactId:  %u\n"), ControlFile.checkPointCopy.nextMulti);
  	printf(_("Time of latest checkpoint:            %s\n"), ckpttime_str);
  	printf(_("Database block size:                  %u\n"), ControlFile.blcksz);
  	printf(_("Blocks per segment of large relation: %u\n"), ControlFile.relseg_size);
Index: src/include/c.h
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/include/c.h,v
retrieving revision 1.181
diff -c -r1.181 c.h
*** src/include/c.h	29 Mar 2005 00:17:16 -0000	1.181
--- src/include/c.h	18 Apr 2005 04:09:09 -0000
***************
*** 365,371 ****
  typedef double float8;
  
  /*
!  * Oid, RegProcedure, TransactionId, SubTransactionId, CommandId, AclId
   */
  
  /* typedef Oid is in postgres_ext.h */
--- 365,372 ----
  typedef double float8;
  
  /*
!  * Oid, RegProcedure, TransactionId, SubTransactionId, MultiXactId,
!  * CommandId, AclId
   */
  
  /* typedef Oid is in postgres_ext.h */
***************
*** 384,389 ****
--- 385,392 ----
  #define InvalidSubTransactionId		((SubTransactionId) 0)
  #define TopSubTransactionId			((SubTransactionId) 1)
  
+ typedef TransactionId MultiXactId;
+ 
  typedef uint32 CommandId;
  
  #define FirstCommandId	((CommandId) 0)
Index: src/include/access/heapam.h
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/include/access/heapam.h,v
retrieving revision 1.99
diff -c -r1.99 heapam.h
*** src/include/access/heapam.h	14 Apr 2005 20:03:27 -0000	1.99
--- src/include/access/heapam.h	18 Apr 2005 22:02:08 -0000
***************
*** 123,128 ****
--- 123,134 ----
  
  /* heapam.c */
  
+ typedef enum
+ {
+ 	LockTupleShared,
+ 	LockTupleExclusive
+ } LockTupleMode;
+ 
  extern Relation relation_open(Oid relationId, LOCKMODE lockmode);
  extern Relation conditional_relation_open(Oid relationId, LOCKMODE lockmode, bool nowait);
  extern Relation relation_openrv(const RangeVar *relation, LOCKMODE lockmode);
***************
*** 155,162 ****
  			CommandId cid, Snapshot crosscheck, bool wait);
  extern HTSU_Result heap_update(Relation relation, ItemPointer otid, HeapTuple tup,
  		ItemPointer ctid, CommandId cid, Snapshot crosscheck, bool wait);
! extern HTSU_Result heap_mark4update(Relation relation, HeapTuple tup,
! 				 Buffer *userbuf, CommandId cid);
  
  extern Oid	simple_heap_insert(Relation relation, HeapTuple tup);
  extern void simple_heap_delete(Relation relation, ItemPointer tid);
--- 161,168 ----
  			CommandId cid, Snapshot crosscheck, bool wait);
  extern HTSU_Result heap_update(Relation relation, ItemPointer otid, HeapTuple tup,
  		ItemPointer ctid, CommandId cid, Snapshot crosscheck, bool wait);
! extern HTSU_Result heap_lock_tuple(Relation relation, HeapTuple tup,
! 				 Buffer *userbuf, CommandId cid, LockTupleMode mode);
  
  extern Oid	simple_heap_insert(Relation relation, HeapTuple tup);
  extern void simple_heap_delete(Relation relation, ItemPointer tid);
Index: src/include/access/htup.h
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/include/access/htup.h,v
retrieving revision 1.73
diff -c -r1.73 htup.h
*** src/include/access/htup.h	28 Mar 2005 01:50:34 -0000	1.73
--- src/include/access/htup.h	16 Apr 2005 18:17:21 -0000
***************
*** 152,163 ****
  										 * attribute(s) */
  #define HEAP_HASEXTENDED		0x000C	/* the two above combined */
  #define HEAP_HASOID				0x0010	/* has an object-id field */
! /* 0x0020, 0x0040 and 0x0080 are unused */
  #define HEAP_XMIN_COMMITTED		0x0100	/* t_xmin committed */
  #define HEAP_XMIN_INVALID		0x0200	/* t_xmin invalid/aborted */
  #define HEAP_XMAX_COMMITTED		0x0400	/* t_xmax committed */
  #define HEAP_XMAX_INVALID		0x0800	/* t_xmax invalid/aborted */
! #define HEAP_MARKED_FOR_UPDATE	0x1000	/* marked for UPDATE */
  #define HEAP_UPDATED			0x2000	/* this is UPDATEd version of row */
  #define HEAP_MOVED_OFF			0x4000	/* moved to another place by
  										 * VACUUM FULL */
--- 152,167 ----
  										 * attribute(s) */
  #define HEAP_HASEXTENDED		0x000C	/* the two above combined */
  #define HEAP_HASOID				0x0010	/* has an object-id field */
! #define HEAP_XMAX_EXCLUSIVE_LOCK		0x0020  /* xmax is exclusive locker */
! #define HEAP_XMAX_SHARED_LOCK	0x0040  /* xmax is shared locker */
! #define HEAP_LOCKED	(HEAP_XMAX_EXCLUSIVE_LOCK | HEAP_XMAX_SHARED_LOCK)
! 
! /* 0x0080 is presently unused */
  #define HEAP_XMIN_COMMITTED		0x0100	/* t_xmin committed */
  #define HEAP_XMIN_INVALID		0x0200	/* t_xmin invalid/aborted */
  #define HEAP_XMAX_COMMITTED		0x0400	/* t_xmax committed */
  #define HEAP_XMAX_INVALID		0x0800	/* t_xmax invalid/aborted */
! /* 0x1000 is presently unused */
  #define HEAP_UPDATED			0x2000	/* this is UPDATEd version of row */
  #define HEAP_MOVED_OFF			0x4000	/* moved to another place by
  										 * VACUUM FULL */
***************
*** 165,171 ****
  										 * VACUUM FULL */
  #define HEAP_MOVED (HEAP_MOVED_OFF | HEAP_MOVED_IN)
  
! #define HEAP_XACT_MASK			0xFFC0	/* visibility-related bits */
  
  
  /*
--- 169,175 ----
  										 * VACUUM FULL */
  #define HEAP_MOVED (HEAP_MOVED_OFF | HEAP_MOVED_IN)
  
! #define HEAP_XACT_MASK			0xEF60	/* visibility-related bits */
  
  
  /*
Index: src/include/access/transam.h
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/include/access/transam.h,v
retrieving revision 1.54
diff -c -r1.54 transam.h
*** src/include/access/transam.h	13 Apr 2005 18:54:57 -0000	1.54
--- src/include/access/transam.h	18 Apr 2005 22:30:21 -0000
***************
*** 86,91 ****
--- 86,95 ----
  {
  	Oid			nextOid;		/* next OID to assign */
  	uint32		oidCount;		/* OIDs available before must do XLOG work */
+ 	MultiXactId	nextMXact;		/* next MultiXactId to assign */
+ 	uint32		mXactCount;		/* MultiXactIds available before XLogging */
+ 	uint32		nextMXoffset;	/* next MultiXactId offset to assign */
+ 	MultiXactId	minMultiXact;	/* oldest known-running MultiXactId */
  	TransactionId nextXid;		/* next XID to assign */
  	TransactionId xidWarnLimit;	/* start complaining here */
  	TransactionId xidStopLimit;	/* refuse to advance nextXid beyond here */
Index: src/include/access/xlog.h
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/include/access/xlog.h,v
retrieving revision 1.59
diff -c -r1.59 xlog.h
*** src/include/access/xlog.h	31 Dec 2004 22:03:21 -0000	1.59
--- src/include/access/xlog.h	16 Apr 2005 18:24:06 -0000
***************
*** 133,138 ****
--- 133,139 ----
  extern void InitXLOGAccess(void);
  extern void CreateCheckPoint(bool shutdown, bool force);
  extern void XLogPutNextOid(Oid nextOid);
+ extern void XLogPutNextMultiXactId(MultiXactId multi);
  extern XLogRecPtr GetRedoRecPtr(void);
  
  #endif   /* XLOG_H */
Index: src/include/catalog/pg_control.h
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/include/catalog/pg_control.h,v
retrieving revision 1.20
diff -c -r1.20 pg_control.h
*** src/include/catalog/pg_control.h	29 Mar 2005 03:01:32 -0000	1.20
--- src/include/catalog/pg_control.h	18 Apr 2005 03:52:11 -0000
***************
*** 22,28 ****
  
  
  /* Version identifier for this pg_control format */
! #define PG_CONTROL_VERSION	74
  
  /*
   * Body of CheckPoint XLOG records.  This is declared here because we keep
--- 22,28 ----
  
  
  /* Version identifier for this pg_control format */
! #define PG_CONTROL_VERSION	81
  
  /*
   * Body of CheckPoint XLOG records.  This is declared here because we keep
***************
*** 39,50 ****
--- 39,52 ----
  	TimeLineID	ThisTimeLineID; /* current TLI */
  	TransactionId nextXid;		/* next free XID */
  	Oid			nextOid;		/* next free OID */
+ 	MultiXactId	nextMulti;		/* next free MultiXactId */
  	time_t		time;			/* time stamp of checkpoint */
  } CheckPoint;
  
  /* XLOG info values for XLOG rmgr */
  #define XLOG_CHECKPOINT_SHUTDOWN		0x00
  #define XLOG_CHECKPOINT_ONLINE			0x10
+ #define XLOG_NEXTMULTI					0x20
  #define XLOG_NEXTOID					0x30
  
  
Index: src/include/nodes/execnodes.h
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/include/nodes/execnodes.h,v
retrieving revision 1.125
diff -c -r1.125 execnodes.h
*** src/include/nodes/execnodes.h	25 Mar 2005 21:58:00 -0000	1.125
--- src/include/nodes/execnodes.h	16 Apr 2005 18:17:21 -0000
***************
*** 317,322 ****
--- 317,323 ----
  	uint32		es_processed;	/* # of tuples processed */
  	Oid			es_lastoid;		/* last oid processed (by INSERT) */
  	List	   *es_rowMark;		/* not good place, but there is no other */
+ 	bool		es_forUpdate;	/* was it FOR UPDATE or FOR SHARE */
  
  	bool		es_instrument;	/* true requests runtime instrumentation */
  	bool		es_select_into; /* true if doing SELECT INTO */
Index: src/include/nodes/parsenodes.h
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/include/nodes/parsenodes.h,v
retrieving revision 1.277
diff -c -r1.277 parsenodes.h
*** src/include/nodes/parsenodes.h	7 Apr 2005 01:51:40 -0000	1.277
--- src/include/nodes/parsenodes.h	18 Apr 2005 22:02:12 -0000
***************
*** 91,97 ****
  								 * clauses) */
  
  	List	   *rowMarks;		/* integer list of RT indexes of relations
! 								 * that are selected FOR UPDATE */
  
  	List	   *targetList;		/* target list (of TargetEntry) */
  
--- 91,100 ----
  								 * clauses) */
  
  	List	   *rowMarks;		/* integer list of RT indexes of relations
! 								 * that are selected FOR UPDATE/SHARE */
! 
! 	bool		forUpdate;		/* true if rowMarks are FOR UPDATE,
! 								 * false if they are FOR SHARE */
  
  	List	   *targetList;		/* target list (of TargetEntry) */
  
***************
*** 688,694 ****
  	List	   *sortClause;		/* sort clause (a list of SortBy's) */
  	Node	   *limitOffset;	/* # of result tuples to skip */
  	Node	   *limitCount;		/* # of result tuples to return */
! 	List	   *forUpdate;		/* FOR UPDATE clause */
  
  	/*
  	 * These fields are used only in upper-level SelectStmts.
--- 691,697 ----
  	List	   *sortClause;		/* sort clause (a list of SortBy's) */
  	Node	   *limitOffset;	/* # of result tuples to skip */
  	Node	   *limitCount;		/* # of result tuples to return */
! 	List	   *lockingClause;	/* FOR UPDATE or FOR SHARE clauses */
  
  	/*
  	 * These fields are used only in upper-level SelectStmts.
